/*
	File:		Headline.cpp
	Contains:	Implementation of the SOM class Headline
	Written by:	PartMaker

	Change History (most recent first):

	<3>	4/18/95	JS		Updated to Developer Release 2
						Add ClonePartInfo.
						Inherited for InitPart, InitPartFromStorage.
						Fixed Externalize() inherited call.
						Removed inherited from Release().
						delete to ODDeleteObject().
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, D. Nelson, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef _CPHEADLINE_
#include "CPHeadline.h"
#endif

#define SOM_Module_headline_Source
#define VARIABLE_MACROS

#ifndef SOM_DartmouthCollege_Headline_xih
#include <Headline.xih>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

//========================================================================================
// DartmouthCollege_Headline
//========================================================================================

SOM_Scope void  SOMLINK DartmouthCollege_HeadlinesomInit(DartmouthCollege_Headline *somSelf)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart = kODNULL;
    DartmouthCollege_Headline_parent_ODPart_somInit(somSelf);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlinesomUninit(DartmouthCollege_Headline *somSelf)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	if (_fCPPart)
		ODDeleteObject(_fCPPart);
    DartmouthCollege_Headline_parent_ODPart_somUninit(somSelf);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFulfillPromise(DartmouthCollege_Headline *somSelf,
		Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDropCompleted(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK DartmouthCollege_HeadlineDragEnter(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK DartmouthCollege_HeadlineDragWithin(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDragLeave(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK DartmouthCollege_HeadlineDrop(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineContainingPartPropertiesChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ContainingPartPropertiesChanged(ev,frame,propertyUnit);
}

SOM_Scope ODStorageUnit*  SOMLINK DartmouthCollege_HeadlineGetContainingPartProperties(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->GetContainingPartProperties(ev,frame));
}

SOM_Scope ODBoolean  SOMLINK DartmouthCollege_HeadlineRevealFrame(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineEmbeddedFrameSpec(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK DartmouthCollege_HeadlineCreateEmbeddedFramesIterator(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDisplayFrameAdded(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
	DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDisplayFrameRemoved(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDisplayFrameConnected(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDisplayFrameClosed(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineAttachSourceFrame(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFrameShapeChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineViewTypeChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlinePresentationChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineSequenceChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineWritePartInfo(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK DartmouthCollege_HeadlineReadPartInfo(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineClonePartInfo(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scopeFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ClonePartInfo(ev,key,partInfo,storageUnitView,scopeFrame);
}

SOM_Scope ODID  SOMLINK DartmouthCollege_HeadlineOpen(DartmouthCollege_Headline *somSelf,
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODFrame*  SOMLINK DartmouthCollege_HeadlineRequestEmbeddedFrame(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineRemoveEmbeddedFrame(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK DartmouthCollege_HeadlineRequestFrameShape(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineUsedShapeChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK DartmouthCollege_HeadlineAdjustBorderShape(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->AdjustBorderShape(ev,embeddedFacet,shape));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFacetAdded(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFacetRemoved(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineCanvasChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineGeometryChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDraw(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineCanvasUpdated(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODCanvas* canvas)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineHighlightChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK DartmouthCollege_HeadlineGetPrintResolution(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK DartmouthCollege_HeadlineCreateLink(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODByteArray* data)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->CreateLink(ev,data));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineLinkUpdated(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODLink* updatedLink,
		ODChangeID id)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->LinkUpdated(ev,updatedLink,id);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineRevealLink(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODLinkSource* linkSource)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineEmbeddedFrameChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODChangeID change)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->EmbeddedFrameChanged(ev,frame,change);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineLinkStatusChanged(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK DartmouthCollege_HeadlineBeginRelinquishFocus(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineCommitRelinquishFocus(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineAbortRelinquishFocus(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFocusAcquired(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineFocusLost(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope ODBoolean  SOMLINK DartmouthCollege_HeadlineHasExtension(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK DartmouthCollege_HeadlineGetExtension(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	return (_fCPPart->GetExtension(ev,extensionName));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineReleaseExtension(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODExtension* extension)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK DartmouthCollege_HeadlinePurge(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODSize size)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    if  (_fCPPart)
		return (_fCPPart->Purge(ev,size));
	else
		return (DartmouthCollege_Headline_parent_ODPart_Purge(somSelf,ev,size));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineIncrementRefCount(DartmouthCollege_Headline *somSelf, 
		Environment *ev)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    DartmouthCollege_Headline_parent_ODPart_IncrementRefCount(somSelf,ev);

	_fCPPart->IncrementRefCount(ev);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineRelease(DartmouthCollege_Headline *somSelf, 
		Environment *ev)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    DartmouthCollege_Headline_parent_ODPart_Release(somSelf,ev);

    if (_fCPPart)
    	_fCPPart->Release(ev);
    	
	if (somSelf->GetRefCount(ev) == 0)
		somSelf->GetStorageUnit(ev)->GetDraft(ev)->ReleasePart(ev, somSelf);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineReleaseAll(DartmouthCollege_Headline *somSelf, 
		Environment *ev)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ReleaseAll(ev);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineExternalize(DartmouthCollege_Headline *somSelf, 
		Environment *ev)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	DartmouthCollege_Headline_parent_ODPart_Externalize(somSelf,ev);

	_fCPPart->Externalize(ev);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineCloneInto(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODStorageUnit* storageUnit,
		ODFrame* initiatingFrame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	DartmouthCollege_Headline_parent_ODPart_CloneInto(somSelf,ev,key,storageUnit,initiatingFrame);

    _fCPPart->CloneInto(ev,key,storageUnit,initiatingFrame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineExternalizeKinds(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODTypeList* kindset)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineChangeKind(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODType kind)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK DartmouthCollege_HeadlineHandleEvent(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->HandleEvent(ev,event,frame,facet,eventInfo));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineAdjustMenus(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineUndoAction(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineRedoAction(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineDisposeActionState(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineWriteActionState(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK DartmouthCollege_HeadlineReadActionState(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
    return (_fCPPart->ReadActionState(ev,storageUnitView));
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineInitPart(DartmouthCollege_Headline *somSelf,
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;
	
	DartmouthCollege_Headline_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPHeadline; // $$$$$ Check to see if it is nil
    _fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
}

SOM_Scope void  SOMLINK DartmouthCollege_HeadlineInitPartFromStorage(DartmouthCollege_Headline *somSelf, 
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    DartmouthCollege_HeadlineData *somThis = DartmouthCollege_HeadlineGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;

	DartmouthCollege_Headline_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPHeadline; // $$$$$ Check to see if it is nil
	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);
}

